/* function from fold.c */
#ifndef SNOFOLD_H
#define SNOFOLD_H
//SPARSE MATRIX
typedef struct node {
  int k;
  int energy;
  struct node *next;
} folden;

//Normal fold
extern float  snofold(const char *sequence, const int max_assym, const int threshold, 
		      const int min_s2, const int max_s2, const int half_stem, const int max_half_stem);
extern void   snofree_arrays(const int length);           /* free arrays for mfe folding */
extern void   snoinitialize_fold(int length); /* allocate arrays for folding */
extern void   snoupdate_fold_params(void);    /* recalculate parameters */
extern int    snoloop_energy(short * ptable, short *s, short *s1, int i);
extern void   snoexport_fold_arrays(int **indx_p, int **mLoop_p, int **cLoop, folden ***fold_p, folden ***fold_p_XS);
extern char * snobacktrack_fold_from_pair(const char *sequence,int i, int j);
//alifold
extern float alisnofold(const char **strings, const int max_assym, const int threshloop, 
			const int min_s2, const int max_s2, const int half_stem, const int max_half_stem);
extern  void  alisnofree_arrays(const int length);
extern  char * alisnobacktrack_fold_from_pair(const char **sequence,int i, int j,int *cov);
extern double cv_fact /* =1 */;
extern double nc_fact /* =1 */;
//max number of mismatch >>>>>..((   )).>>>> 
#define MISMATCH 3

#endif
